<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-paperclip</v-icon>
            <b>Histórico de Anexos</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon v-on="on" style="position:absolute; right: 15px" color="red" @click="close"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <v-card-text class="scrollForm">
        <v-row class="px-5" no-gutters>
          <div
            v-for="(answer, index) in answersTeam.answers"
            :key="index"
            style="line-height: 1.5rem; width: 100%"
          >
            <section v-if="index == 0">
              <b style="font-size: 1.05rem">#Resposta</b>
              <br/>
              <br/>
              <b>Título: </b>{{ answer.title }}
              <br />
              <!-- <b>Conteúdo: </b><br /><br /><span v-html="answer.comment" /><br /> -->
              <b style="line-height: 2rem">Histórico de Anexos: </b>

              <span v-if="answer.files.length == 0">
                não tem anexos
              </span>
              <span v-else>
                <div v-for="(file, ind) in answer.files" :key="ind">
                  {{ ind + 1 }}º -
                  <v-chip
                    :color="ind + 1 == answer.files.length ? 'primary' : ''"
                    small
                    class="mb-1"
                    @click.stop="downloadFile(answer._id, file.name, file._id)"
                    >{{ file.name }}</v-chip
                  >
                  <span style="font-size: 0.7rem" class="pl-2">
                    <span v-if="ind == answer.files.length - 1"><b>** Ultimo envio **</b></span>

                    por {{ showSendBy(file.sendBy) }} -
                    <span v-html="compareData(file.timestamp)" />
                  </span>
                </div>
              </span>
              <!-- Anexar  -->
              <input id="fileInput" type="file" style="display: none" @change="selectFile" />
              <br />
              <!-- <div style="text-align: center">
                <v-btn
                  color="primary"
                  class="px-2 mt-1 mb-2"
                  outlined
                  @click="attachFile(index)"
                  elevation="0"
                  small
                >
                  Anexar Arquivo
                </v-btn>
              </div> -->
              <br/>
              <div style="text-align: center" class="mt-3">
                <b>**Atenção</b>, apenas o ultimo arquivo anexado será enviado para correção do
                professor.
              </div>
              <br/>
              <v-divider class="my-4" />
            </section>
          </div>
        </v-row>
      </v-card-text>
      <v-card-actions class="mt-n2 pb-3 pr-6">
        <v-spacer></v-spacer>
        <v-btn color="primary" text @click="close">Cancelar</v-btn>
      </v-card-actions>
    </v-card>
  </v-row>
</template>
<script>
import CollaborativeWork from '../../services/collaborativeWork'
import { Utils } from '../../utils/utils'

export default {
  name: 'AnswersAttach',
  props: {
    answersTeam: {
      type: Object,
      default: () => {},
    },
    idAnswer: { type: String },
    availableUsers: {
      type: Array,
      default: () => {
        return []
      },
    },
  },
  data() {
    return {
      answers: [],
      attach: null,
      attachName: '',
      attachIndex: '',
      userLogged: {},
      userLoggedAnswers: 0,
    }
  },
  computed: {
    checkPermissions() {
      // usar checkPermissions.get('nome da permissão')
      return this.$store.state.user.mappedActions
    },
  },
  async created() {
    const userInfo = await this.$getItem('userInfo')
    this.userLogged = userInfo

    this.answersTeam.answers.forEach((item) => {
      if (item.sendBy == this.userLogged.id) this.userLoggedAnswers++
    })
  },
  watch: {
    'answersTeam.answers'() {
      this.answersTeam.answers.forEach((item) => {
        if (item.sendBy == this.userLogged.id) this.userLoggedAnswers++
      })
    },
  },
  methods: {
    close() {
      this.$emit('closeAttachments')
    },
    compareData(timestamp) {
      return Utils.compareDate(timestamp)
    },
    showSendBy(id) {
      let user
      this.availableUsers.forEach((data) => {
        if (data.id == id) user = data
      })
      return `${user.name} ${user.surname}`
    },

    downloadFile(answerId, name, fileId) {
      console.log(`id da resposta: ${answerId}`)
      console.log(`inicia o download de id: ${fileId} e nome: ${name}`)
      this.downloadAttach(this.idAnswer, this.answersTeam._id, answerId, fileId, name)
    },

    async downloadAttach(collaborativeWorkAnswerId, teamId, answerId, fileId, fileName) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkReadAllAvailable').id

        const ret = await CollaborativeWork.downloadFileAnswer(
          routedEntity.id,
          actionId,
          {
            collaborativeWorkAnswerId: collaborativeWorkAnswerId, // id resposta a ser deletada
            teamId: teamId, //id time
            answerId: answerId, // id resposta trabalho colaborativo
            fileId: fileId,
          },
          fileName
        )
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    attachFile(index) {
      this.attachIndex = index
      console.log(index)
      document.getElementById('fileInput').click()
    },

    async selectFile(file) {
      let selectedFile = file.target.files[0]
      const formData = new FormData()
      formData.append('localFile', selectedFile)
      this.attach = formData
      this.attachName = selectedFile.name

      await this.uploadFileToAnswer(
        this.idAnswer,
        this.answersTeam._id,
        this.answersTeam.answers[this.attachIndex]._id,
        this.attachName,
        this.attach
      )
    },
    async uploadFileToAnswer(collaborativeWorkAnswerId, teamId, teamAnswerId, fileName, formData) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

        let ret = await CollaborativeWork.attachAnswerFile(
          entityId,
          actionId,
          collaborativeWorkAnswerId,
          teamId,
          teamAnswerId,
          fileName,
          formData
        )
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Arquivo foi <b>anexado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })

          this.$emit('answerAddFileDone')
        } else {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Desculpe não foi possível <b>anexar</b> o arquivo!',
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>
<style scoped>
.attachInput {
  display: none;
}
</style>
